﻿define(['jquery', 'util', 'jquery-ui', 'audioplayer'], function ($, util) {
	var dims = {}, container = null, app_data = null,
			CONTROL_MODE = 'control', SERIAL_MODE = 'continuous', TRAINING_MODE = 'training', QUESTION_CNT = 'question_cnt',
			get_control_score = function (score, tier) {
				var coefs = [1, 0.9, 0.75, 0], max_score = 1 / app_data.num_tasks, coef = tier > coefs.length ? 0 : coefs[tier - 1];
				return Math.round(max_score * coef * score);
			},
			get_total_control_score = function () {
				var res = 0, i = app_data.num_tasks;
				while (i--) {
					res += app_data.tasks[i].current_result;
				}
				return res;
			}
	get_random_component_id = function (length, showed) {
		if (length == 1)
			return 0;
		if (!showed || showed.length >= length)
			return Math.floor(Math.random() * length);
		var ids = [];
		for (var i = 0; i < length; i++) {
			if (showed.indexOf(i) == -1)
				ids.push(i);
		}
		return ids[Math.floor(Math.random() * ids.length)];
	},
			stop_audio = function () {
				var a = $('audio#question_audio')[0];
				if (a && a.readyState > 1 && !a.paused) {
					a.pause();
					a.currentTime = 0;
				}
			}
	adjust_sizes = function (cb) {
		window.gScale = util.scale_page(true);
		//var main = $('#main'), q_cnt = $('#question_cnt');
		//q_cnt.css('top',(main.children('h1').outerHeight())+'px');
		var tpl_cnt = $('#tpl_cnt');
		//tpl_cnt.css('top',(q_cnt.children('h2').outerHeight())+'px');
		//dims = {width: main.width(), height: main.height()};
		if ($('#modal').is(':visible')) {
			if ($('#modal img').length > 0) {
				var mh = $('#modal').parent().height(), im = $('#modal img')[0], wh = window.innerHeight, ww = window.innerWidth;
				var ratioX = im.naturalWidth / (ww - 30),
						ratioY = im.naturalHeight / (wh - 60), attr = '';
				//im.height = '';
				//im.width = '';
				if (ratioX > ratioY && ratioX > 1) {
//attr = ' width="'+(dims.width-50)+'"';
					im.width = (window.innerWidth - 100);
					im.height = im.width / im.naturalWidth * im.naturalHeight;
				} else if (ratioY > ratioX && ratioY > 1) {
//attr = ' height="'+(dims.height-100)+'"';
					im.height = (window.innerHeight - 100);
					im.width = im.height * im.naturalWidth / im.naturalHeight;
				}
			}
			/*if (mh>wh-20) {
			 $('#modal img').css('height',(ih-mh+wh-20)+'px');
			 }*/
			$('#modal').parent().position({
				'my': 'center', 'at': 'center', of: window
			});
		}
		if (typeof cb == 'function') {
			cb(tpl_cnt.width(), tpl_cnt.height());
		}
	};
	return {
		// render the main interface of the test
		render_main: function (elem, data) {
			$('#main').attr('data-mode', data.mode);
			dims = {width: $(elem).width(), height: $(elem).height()};
			container = $(elem);
			app_data = data;
			util.set_path(data.path);
			var res = '<div class="header"><div class="logo"></div><h1>' + util.get_html(data.data.find('title')) + '</h1><div id="question_head"></div></div><div id="counter">';
			for (var i = 0; i < data.num_tasks; i++) {
				res += '<div class="q_bullet ' + (i == data.cur_task ? 'active' : '') + '" id="q_bullet_' + i + '" data-qnum="' + i + '" >№' + (i + 1) + '</div>';
			}

			res += '</div><div class="main_part"><div id="' + QUESTION_CNT + '"></div><div id="footer">';
			res += '<div id="score" class="hide"></div><div id="buttons">\
					<a href="javascript:void(0)" id="correct_btn"><i></i>Правильный ответ</a>\
					<a href="javascript:void(0)" id="tip_btn"><i></i>Подсказка</a>\
					<a href="javascript:void(0)" id="help_btn"><i></i>Помощь</a>\
					<a href="javascript:void(0)" id="back_btn"><i></i>Назад</a>\
					<a href="javascript:void(0)" id="again_btn"><i></i>Ещё раз</a>\
					<a href="javascript:void(0)" id="next_btn">Далее<i></i></a>\
					<a href="javascript:void(0)" id="check_btn"><i></i>Проверить</a></div>';
			res += '</div></div>\
					<div id="modal" style="display:none"></div>';
			$(elem).html(res);
			//$('#question_cnt').css('top',$(elem).find('h1').outerHeight()+'px');
			//var fon = data.data.attr('fon');
			//if(fon) $(elem).css('background-image','url('+data.path+fon+')'); 
			this.render_question(true);
			this.init_events(elem);
			/////
			$('#back_btn,#next_btn,#again_btn').remove();
		},
		// reinit - render the question as already andswered or not
		render_question: function (reinit) {
			if (!reinit) {
				$('#check_btn').removeClass('inactive');
			}
			var elem = '#' + QUESTION_CNT,
					data = app_data,
					id = data.cur_task,
					task = data.tasks[id];
			$('#tmp_style').remove();
			$('.main_part .audioplayer').remove();
			$('#tpl_cnt').attr('style', '');
			reinit = !task.state || reinit;
			var comp_id = ((reinit && task.correct_showed) || task.current == null) ? get_random_component_id(task.ncomps, task.showed) : task.current,
					comp = $(task.comps[comp_id]),
					type = comp.attr('type').toLowerCase(),
					question = comp.find('question'),
					t = this,
					res = '';
			if (reinit) {
				task.current = comp_id;
				task.state = null;
				task.tier++;
				if (task.showed.indexOf(comp_id) == -1)
					task.showed.push(comp_id);
				$('#score').html('');
			}
			if (question.attr('picture')) {
				//res = this.render_image(question.attr('picture'), question.attr('zoom') != 'no', question.attr('cutline'));
			}
			//res = '<h2>'+util.get_html(question)+res+'</h2>'
			$('#question_head').html(util.get_html(question));
			if (question.attr('picture')) {
				var head_img = new Image();
				head_img.src = question.attr('picture');
				if (question.attr('zoom') != 'no') {
					$('#question_head').append(' (<a href="#" class="picture_popup" data-action="popup" src="' + question.attr('picture') + '"> картинка </a>) ');
				} else {
					$('#question_head').append('<br/>' + this.render_image(question.attr('picture'), false, question.attr('cutline')));
				}
			}
			var audio = comp.find('audio'), audio_autoplay = false;
			if (audio.length > 0 && audio.attr('sound')) {
				var fname = audio.attr('sound'), ext = fname.substr((~-fname.lastIndexOf(".") >>> 0) + 2).toLowerCase();
				$('.main_part').prepend('<audio id="question_audio" controls="controls" preload="auto" ' + (''/*audio.attr('autostart')=='yes'?'autoplay="autoplay"':''*/) + '>\
						<source src="' + data.path + fname + '" type="audio/' + (ext == 'wav' ? 'wav' : 'mpeg') + '" />\
						</audio>');
				audio_autoplay = audio.attr('autostart') == 'yes' ? true : false;
			}
			res += '<div id="tpl_cnt"></div>';
			$('#q_bullet_' + id).removeClass('correct incorrect partial');
			if (!$('#q_bullet_' + id).hasClass('active')) {
				$('.q_bullet.active').removeClass('active');
				$('#q_bullet_' + id).addClass('active');
			}
			$(elem).html(res);
			if (audio.length > 0 && audio.attr('sound')) {
				$('#question_audio').audioPlayer();
			}
			/*if(audio.length>0 && audio.attr('sound')) {
			 $('#'+QUESTION_CNT+' h2').css('margin-right','250px');
			 }*/

			var afterload = function (cb) {
				$('#tpl_cnt').css('max-height', (620 - $('.header').outerHeight()) + 'px');
				$('#question_cnt').css('max-height', (620 - $('.header').outerHeight()) + 'px');
				requirejs(['tpl/' + type], function (tpl) {
					$('#tpl_cnt').show();
					var tip = comp.find('prompt');
					tip = tip.length > 0 ? tip : null;
					if (tip && tip.attr('picture')) {
						(new Image()).src = app_data.path + tip.attr('picture');
					}
					tpl.init_question('#tpl_cnt', comp, task.state, t, function () {
						t.reinit_buttons(tpl, reinit, tip);
						$(window).off('resize orientationchange').on('resize orientationchange', function () {
							adjust_sizes(tpl.resize)
						});
						adjust_sizes(tpl.resize);
					});
					if (audio_autoplay) {
						$('#question_audio')[0].play();
						if (!$('#question_audio')[0].paused)
							$('.audioplayer').addClass('audioplayer-playing').removeClass('audioplayer-stopped')
					}
					//t.reinit_buttons(tpl,reinit,tip);
					if (typeof cb == 'function') {
						cb(tpl);
					}
				});
			};
			var cb = function (tpl) {
				if (!reinit) {
					if (typeof task.answers_disabled != 'undefined' && task.answers_disabled) {
						tpl.disable_answers();
					}
				}
			}
			if (question.attr('picture')) {
				$(head_img).on('load error', function () {
					$(this).parent().css('width', $(this).width() + 'px');
					afterload(cb);
				});
			} else {
				afterload(cb);
			}
		},
		reinit_buttons: function (tpl, reinit, tip) {
			var t = this,
					data = app_data,
					cur_id = data.cur_task,
					mode = app_data.mode,
					back_btn = $('#back_btn'),
					again_btn = $('#again_btn'),
					next_btn = $('#next_btn'),
					check_btn = $('#check_btn'),
					correct_btn = $('#correct_btn'),
					tip_btn = $('#tip_btn'),
					q_bullet = $('.q_bullet'),
					help_btn = $('#help_btn');
			if (typeof mode == 'undefined' || !mode) {
				app_data.mode = mode = TRAINING_MODE;
			}
			if (mode == CONTROL_MODE) {
				correct_btn.remove();
				tip_btn.remove();
			}

			$('#buttons a').hide();
			help_btn.show();
			check_btn.show();
			if (cur_id > 0 && mode != SERIAL_MODE) {
				back_btn.show();
			}

			q_bullet.off('click').on('click', function (e) {
				app_data.cur_task = $(e.target).closest('.q_bullet').attr('data-qnum');
				t.render_question(false);
			});
			check_btn.off('click').on('click', function (e, forceNotAllChoosedCheck, forceNotDoneCheck, silentCheck) {

				if (typeof silentCheck == 'undefined') {
					silentCheck = false;
				}
				if ($(this).hasClass('inactive') && !silentCheck) {
					return;
				}
				if (typeof forceNotAllChoosedCheck == 'undefined') {
					if (mode == CONTROL_MODE) {
						forceNotAllChoosedCheck = true;
					} else {
						forceNotAllChoosedCheck = false;
					}
				}

				var isDone = tpl.process_answer(function (res, score, state) {
					stop_audio();
					var task = data.tasks[cur_id];
					task.state = state;
					if (mode == CONTROL_MODE) {
						task.current_result = get_control_score(score, task.tier);
						$('#score').html('Вы набрали ' + get_total_control_score() + ' из 100 баллов');
					} else if (mode == TRAINING_MODE || app_data.all_done) {
						$('#score').removeClass('correct incorrect partial').addClass(res == 1 ? 'correct' : (res == -1 ? 'incorrect' : 'partial'))
								.html(res == 1 ? 'Правильно' : (res == -1 ? 'Неверно' : 'Ответ не полный'));
						switch (res) {
							case 0:
								if (!silentCheck) {
									tpl.enable_answers();
									t.taskNotFullRightAnswerMsg();
								}
								return;
								break;
							case -1:
								tpl.enable_answers();
								if (typeof task.tries == 'undefined') {
									task.tries = 0;
								}
								task.tries++;
								break;
						}
					}
					$('#q_bullet_' + cur_id).removeClass('correct incorrect partial').addClass(res == 1 ? 'correct' : (res == -1 ? 'incorrect' : 'partial'));
					stop_audio();
					if (mode == CONTROL_MODE) {
						check_btn.hide();
					} else {
						if (res == 1) {
							check_btn.addClass('inactive');
						}

					}

					if (mode == SERIAL_MODE && !app_data.all_done) {
						if (app_data.cur_task < app_data.tasks.length - 1) {
							app_data.cur_task++;
						} else {
							app_data.all_done = true;
							app_data.cur_task = 0;
						}
						t.render_question(false);
						return;
					}
					if (cur_id < data.tasks.length - 1) {
						next_btn.show();
					}
					if (cur_id > 0) {
						back_btn.show();
					}
					//if(mode == SERIAL_MODE) {
					again_btn.show();
					//}
					if (res == 1) {
						tpl.disable_answers();
						if (!silentCheck) {
							t.taskRightAnsweredMsg({
								close: function (event, ui) {
									t.nextTask();
									$(event.target).dialog('destroy');
								}
							});
						}
						tip_btn.addClass('inactiv');
						correct_btn.addClass('inactive');

					}
					if (res == -1) {
						if (!silentCheck) {
							t.taskWrongAnsweredMsg();
						}
					}
					if (res < 1) {
						if (mode != CONTROL_MODE) {
							if (task.tries >= 2) {
								tip_btn.removeClass('inactive');
							}
							if (task.tries >= 3) {
								correct_btn.removeClass('inactive');
							}

						}
						//again_btn.show();
					}

				}, forceNotAllChoosedCheck, forceNotDoneCheck);
				if (!isDone && !silentCheck) {
					t.taskNotDoneMsg();
				}

			});
			correct_btn.show().addClass('inactive');
			if (!reinit) {
				check_btn.trigger('click', [undefined, undefined, true]);
				if (data.tasks[cur_id].correct_showed) {
					$('#check_btn').addClass('inactive');
					correct_btn.removeClass('inactive');
				}
			} else {
				check_btn.removeClass('inactive');
			}
			correct_btn.off('click').on('click', function () {
				if ($(this).hasClass('inactive')) {
					return false;
				}
				stop_audio();
//				tpl.show_correct();
				if (typeof tpl.get_correct_answer_text == 'function') {
					$('#modal').html('<div class="AnswerMsg">' + tpl.get_correct_answer_text() + '</div>').dialog({
						modal: true,
						resizable: false,
						draggable: false,
						width: 'auto',
						title: ''
					});
				}
				check_btn.addClass('inactive');
				data.tasks[cur_id].correct_showed = true;
				$('#q_bullet_' + cur_id).removeClass('correct incorrect partial').addClass('correct_showed');
				tpl.disable_answers();
				data.tasks[cur_id].answers_disabled = true;
			});
			again_btn.off('click').on('click', function () {
				//stop_audio();
				if (mode == SERIAL_MODE) {
					var i = app_data.num_tasks;
					while (i--) {
						app_data.tasks[i].state = null;
						app_data.tasks[i].current = null;
					}
					$('.q_bullet').removeClass('correct incorrect partial')
					app_data.cur_task = 0;
					app_data.all_done = false;
				} else if (mode == CONTROL_MODE) {
					app_data.tasks[cur_id].current = null;
				}
				t.render_question(true);
			});
			next_btn.off('click').on('click', function () {
				//stop_audio();
				app_data.cur_task++;
				t.render_question(false);
			});
			back_btn.off('click').on('click', function () {
				//stop_audio();
				app_data.cur_task--;
				t.render_question(false);
			});
			help_btn.off('click').on('click', function () {
				$(document).on('click', '.helpMessage .helpMessage-yes-button', function () {
					$('#modal').dialog('close')
				});
				if (typeof tpl.get_help_tpl == 'function') {
					var $tpl = tpl.get_help_tpl();
				} else {
					var comp_type = $(data.tasks[data.cur_task].comps[data.tasks[data.cur_task].current]).attr('type');
					if (comp_type == '') {
						comp_type = 'comboboxtest';
					}
					var $tpl = $('.' + comp_type + '-tpls .tpl-helpMessage').clone(true).children();
				}
				$tpl.html($tpl.html().split('[[showPromptButtonAfter]]').join(app_data.showPromptButtonAfter).split('[[showRightAnswerButtonAfter]]').join(app_data.showRightAnswerButtonAfter));
				if (!tip) {
					$tpl.find('.helpMessage-prompt-text').hide();
				} else {
					$tpl.find('.helpMessage-prompt-text').show();
				}
				$('#modal').html($tpl).dialog({
					modal: true,
					resizable: false,
					draggable: false,
					width: 'auto'
				});
			});
			tip_btn.show().addClass('inactive');
			if (!tip) {
				tip_btn.hide();
			}
			tip_btn.off('click').on('click', function () {
				if ($(this).hasClass('inactive')) {
					return;
				}
				stop_audio();
				if (!tip)
					return;
				data.tasks[cur_id].tip_showed = true;
//				correct_btn.show();
//				tip_btn.hide();
				var img = tip.attr('picture');
				$('#modal').html(
						(img ? t.render_image(img, false, '', 'auto', 'auto', 'max-width: 100%;') : '') +
						util.get_html(tip)
						).dialog({
					modal: true,
					resizable: false,
					draggable: false,
					width: 'auto',
					title: 'Подсказка'
				});
				if (img) {
					$('#modal img').on('load error', function () {
						var t = this;
						//setTimeout(function(){
						var mh = $('#modal').parent().height(), ih = $(t).height(), wh = $(window).height();
						if (mh > wh - 20) {
							$(t).css('height', (ih - mh + wh - 20) + 'px');
						}
						$('#modal').parent().position({
							'my': 'center', 'at': 'center', of: window
						});
						//},10);
					});
				}
			});
		},
		init_events: function (elem) {
			$(elem).on('click tap', '[data-action=popup]', function (e) {
				e.preventDefault();
				e.stopPropagation();
				stop_audio();
				var im = new Image();
				var t = $(this);
				if (!t.attr('src')) {
					t = t.find('img');
				}
				im.src = t.attr('src');
				im.alt = t.attr('alt') || '';
				var ratioX = im.naturalWidth / (window.innerWidth - 30),
						ratioY = im.naturalHeight / (window.innerHeight - 60), attr = '';
				if (ratioX > ratioY && ratioX > 1) {
					//attr = ' width="'+(dims.width-50)+'"';
					im.width = (window.innerWidth - 100);
				} else if (ratioY > ratioX && ratioY > 1) {
					//attr = ' height="'+(dims.height-100)+'"';
					im.height = (window.innerHeight - 100);
				}
				$('#modal').html(
						im
						).append((im.alt ? '<span>' + im.alt + '</span>' : '')).dialog({
					modal: true,
					resizable: false,
					draggable: false,
					width: 'auto',
					title: t.attr('alt')
				});
			});
		},
		render_image: function (name, zoom, text, height, width, style) {
			var path = app_data.path + name, fname = path.split('/').pop(), ret = '',
					tnheight = height || 100, tnwidth = width || 'auto',
					ext = fname.substr((~-fname.lastIndexOf(".") >>> 0) + 2).toLowerCase();
			if (ext == 'swf') {
				path = path.replace('.swf', '.png');
			}
			ret = '<div class="picture ' + (zoom ? 'thumbnail' : '') + '" ' + (zoom ? 'data-action="popup"' : '') + '><img src="' + path + '" ' +
					(zoom ? 'height="' + tnheight + '" width="' + tnwidth + '"' : '') + ' alt="' + (text ? text : '') +
					'" ' + (style ? 'style="' + style + '" ' : '') + '/>' + (text ? '<span>' + text + '</span>' : '') + '</div>';
			return ret;
		},
		taskNotDoneMsg: function () {
			if (app_data.mode == CONTROL_MODE) {
				$('#modal').html('<div class="modal-taskNotFullRightAnswerMsg">Задание не выполнено. Проверить? <div class="taskNotFullRightAnswerMsg-btns"><input type="button" value="Да" onclick="$(\'#modal\').dialog(\'close\');$(\'#check_btn\').trigger(\'click\',[undefined,true]);"/><input type="button" value="Нет" onclick="$(\'#modal\').dialog(\'close\')"/></div></div>').dialog({modal: true});
			} else {
				$('#modal').html('<div class="modal-taskNotDoneMsg">Задание не выполнено.<div class="taskNotDoneMsg-ok-btn"><input type="button" value="ok" onclick="$(\'#modal\').dialog(\'close\')"/></div></div>').dialog({modal: true});
			}
			return;
		},
		taskNotFullRightAnswerMsg: function () {
			$('#modal').html('<div class="modal-taskNotFullRightAnswerMsg">Задание выполнено не полностью, проверить?<div class="taskNotFullRightAnswerMsg-btns"><input type="button" value="Да" onclick="$(\'#modal\').dialog(\'close\');$(\'#check_btn\').trigger(\'click\',[true]);"/><input type="button" value="Нет" onclick="$(\'#modal\').dialog(\'close\')"/></div></div>').dialog({modal: true});
			return;
		},
		taskWrongAnsweredMsg: function () {
			if (app_data.mode == CONTROL_MODE) {
				$('#modal').html('<div class="modal-taskWrongAnswerMsg">Задание выполнено неверно.<div class="taskRightAnsweredMsg-ok-btn"><input type="button" value="Ok" onclick="$(\'#modal\').dialog(\'close\')"/></div></div>').dialog({modal: true});
			} else {
				$('#modal').html('<div class="modal-taskWrongAnswerMsg">Есть ошибки, попробуй ещë раз.<div class="taskWrongAnswerMsg-ok-btn"><input type="button" value="Ok" onclick="$(\'#modal\').dialog(\'close\')"/></div></div>').dialog({modal: true});
			}
			return;
		},
		taskRightAnsweredMsg: function (params) {
			if (typeof params == 'undefined') {
				params = {};
			}
			var dialogParams = {modal: true};
			if (typeof params.close != 'undefined') {
				dialogParams.close = params.close;
			}

			if (app_data.mode == CONTROL_MODE) {
				$('#modal').html('<div class="modal-taskRightAnsweredMsg">Задание выполнено верно.</div>').dialog({modal: true});
			} else {
				$('#modal').html('<div class="modal-taskRightAnsweredMsg">Молодец!<div class="taskRightAnsweredMsg-ok-btn"><input type="button" value="Ok" onclick="$(\'#modal\').dialog(\'close\')"/></div></div>')
						.dialog(dialogParams);
			}

			return;
		},
		nextTask: function () {
			if (app_data.cur_task < app_data.tasks.length - 1) {
				app_data.cur_task++;
				this.render_question(false);
			}
		}
	}
});