/* Russian keyboard layouts
 * contains layout: 'russian-qwerty' & 'russian-mac'
 *
 * To use:
 *  Point to this js file into your page header: <script src="layouts/russian.js" type="text/javascript"></script>
 *  Initialize the keyboard using: $('input').keyboard({ layout: 'russian-qwerty' });
 *
 * license for this file: WTFPL, unless the source layout site has a problem with me using them as a reference
 */

/* Thanks to Yury Kotlyarov (https://github.com/yura) */
$.keyboard.layouts['my-english'] = {
	'name' : 'My-qwerty',
	'lang' : ['ru'],
	'default' : [
		"1 2 3 4 5 6 7 8 9 0 {b}",
		"q w e r t y u i o p",
		"a s d f g h j k l",
		"{s} z x c v b n m {s}",
		"{accept} {space} {cancel}"
	],
	'shift' : [
		'! " \' ; % : ? - , . {b}',
		"Q W E R T Y U I O P",
		'A S D F G H J K L',
		"{s} Z X C V B N M {s}",
		"{accept} {space} {cancel}"
	]
};

$.keyboard.layouts['my-russian'] = {
	'name' : 'My-Russian-qwerty',
	'lang' : ['ru'],
	'default' : [
		"\u0451 1 2 3 4 5 6 7 8 9 0 {b}",
		"\u0439 \u0446 \u0443 \u043a \u0435 \u043d \u0433 \u0448 \u0449 \u0437 \u0445 \u044a",
		"\u0444 \u044b \u0432 \u0430 \u043f \u0440 \u043e \u043b \u0434 \u0436 \u044d ",
		"{s} \u044f \u0447 \u0441 \u043c \u0438 \u0442 \u044c \u0431 \u044e {s}",
		"{accept} {space} {cancel}"
	],
	'shift' : [
		'\u0401 ! " \' ; % : ? - , . {b}',
		"\u0419 \u0426 \u0423 \u041a \u0415 \u041d \u0413 \u0428 \u0429 \u0417 \u0425 \u042a",
		"\u0424 \u042b \u0412 \u0410 \u041f \u0420 \u041e \u041b \u0414 \u0416 \u042d",
		"{s} \u042f \u0427 \u0421 \u041c \u0418 \u0422 \u042c \u0411 \u042e {s}",
		"{accept} {space} {cancel}"
	]
};

$.keyboard.layouts['my-num'] = {
	'name' : 'My-num',
	'lang' : ['ru'],
	'default' : [
		"7 8 9",
		"4 5 6",
		"1 2 3",
		", 0 -",
		"{accept} {clear}"
	]
};
// Keyboard Language
// please update this section to match this language and email me with corrections!
// ru = ISO 639-1 code for Russian
// ***********************
jQuery.keyboard.language.ru = {
	display : {
		'a'      : '\u2714:Принять (Shift-Enter)', // check mark - same action as accept
		'accept' : 'Принять:Принять (Shift-Enter)',
		'alt'    : 'AltGr:Alternate Graphemes',
		'b'      : '\u2190:Backspace',    // Left arrow (same as &larr;)
		'bksp'   : 'Bksp:Backspace',
		'c'      : '\u2716:Отменить (Esc)', // big X, close - same action as cancel
		'cancel' : 'Отменить:Отменить (Esc)',
		'clear'  : 'C:Clear',             // clear num pad
		'combo'  : '\u00f6:Toggle Combo Keys',
		'dec'    : ',:Decimal',           // decimal point for num pad (optional), change '.' to ',' for European format
		'e'      : '\u21b5:Enter',        // down, then left arrow - enter symbol
		'enter'  : 'Enter:Enter',
		'lock'   : '\u21ea Lock:Caps Lock', // caps lock
		's'      : ' \u21e7 :Shift',        // thick hollow up arrow
		'shift'  : 'Shift:Shift',
		'sign'   : '\u00b1:Change Sign',  // +/- sign for num pad
		'space'  : '_:Space',
		't'      : '\u21e5:Tab',          // right arrow to bar (used since this virtual keyboard works with one directional tabs)
		'tab'    : '\u21e5 Tab:Tab'       // \u21b9 is the true tab symbol (left & right arrows)
	},
	// Message added to the key title while hovering, if the mousewheel plugin exists
	wheelMessage : 'Use mousewheel to see other keys',
};
