define(function(){
	var im_to_load = 0, im_loaded = 0, path = '-', global_scale = 1;
	return {
		set_path: function(s) {
			path = s;
		},
		has_touch: function() {
			return ('ontouchstart' in document.documentElement);
		},
		load_images: function(arr,cb) {
			if (path=='-') {
				return;
			}
			im_to_load = arr.length; 
			im_loaded = 0;
			if (im_to_load == 0) {
				cb(arr);
				return;
			}
			for (var i=0; i<im_to_load; i++) {
				(function(i) {
					var img = new Image();
					img.onload = function(){
						im_loaded++;
						arr[i].width = img.width;
						arr[i].height = img.height;
						if (im_loaded >= im_to_load) {
							cb(arr);
						}
					};
					img.src = path+arr[i].src;
				})(i);
			}
		},
		get_url_param: function(name) {
			var regexS = "[\\?&%]"+name+"=([^&#]*)";
			var regex = new RegExp( regexS );
			var results = regex.exec( window.location.href );
			if( results == null )
				return null;
			else
				return results[1];
		},
		array_shuffle: function(arr) {
			var i, temp, j, len = arr.length;
			for (i = 0; i < len; i++) {
					j = Math.floor(Math.random() * (i + 1));
					temp = arr[i];
					arr[i] = arr[j];
					arr[j] = temp;
			}
			return arr;
		},
		trim_remove_empty: function(a) {
			var len = a.length, res = [], j=0;
			if(i) for(var i=0; i<l; i++) {
				if(typeof a[i] != 'undefined') {
					var str = a[i].trim();
					if(str.length > 0) {
						res[j++] = str;
					}
				}
			}
			return res;
		},
		longest_string: function(a) {
		  var c = 0, d = 0, l = 0, i = a.length;
		  if (i) while (i--) {
			d = a[i].length;
			if (d > c) {
			  l = i;
			  c = d;
			}
		  }
		  return a[l];
		},
		get_html: function(el) {
			if (el.length == 0) {
				return '';
			}
			var res;
			if (!(res = el.html())) {
				var tmp_cnt = $('<div id="tmp" style="display:none;"></div>').appendTo('body');
				$(el[0].childNodes).clone().appendTo(tmp_cnt);
				res =  tmp_cnt.html();
				tmp_cnt.remove();
			}
			return res.replace('<![CDATA[','').replace(']]>','');
			
		},
		scale_page: function(recalc) {
			if(recalc) {
				var ww = window.innerWidth, wh = window.innerHeight, m = $('#main'), mw = m.width()-1, mh = m.height()-1,
					cw = ww/mw, ch = wh/mh;
				if(cw < ch) {
                    m.css({top:(wh - mh*cw) / 2 + "px",
							left:'-1px',
							webkitTransform: "scale(" + cw + "," + cw + ") ",
							transform : "scale(" + cw + "," + cw + ") "});
					global_scale = cw;
				} else {
                    m.css({top:'-1px',
							left:(ww - mw*ch) / 2 + "px",
							webkitTransform: "scale(" + ch + "," + ch + ") ",
							transform : "scale(" + ch + "," + ch + ") "});
					global_scale = ch;
				}
			}
			return global_scale;
		}
	}
});