define(['jquery', 'util', 'jquery-ui', 'jquery.ui.touch-punch'], function ($, util) {
	var pictures = null, show_cells = null, psize, csize,
			get_random_elements = function (arr, nselect) {
				var arr2 = util.array_shuffle(arr);
				return (nselect < arr.length ? arr2.slice(0, nselect) : arr2);
			},
			calc_size = function (number, el) {
				var width = $(el).width() - 10;
				var height = $(el).height() - 2;
				var do_calc = function (width, height) {
					var area = height * width;
					var elementArea = parseInt(area / number);
					var sideLength = parseInt(Math.sqrt(elementArea));
					var numX = Math.ceil(width / sideLength);
					sideLength = width / numX;
					while (numX <= number) {
						if (Math.floor(height / sideLength) * numX >= number) {
							return sideLength;
						}
						numX++;
						sideLength = width / numX;
					}
					sideLength = height;
					return Math.floor(sideLength);
				}
				return Math.max(do_calc(width, height), do_calc(height, width))
			},
			create_style = function (psize, csize) {
				var ex = document.getElementById('tmp_style');
				if (ex) {
					ex.parentNode.removeChild(ex);
				}
				var style = document.createElement('style');

				style.type = 'text/css';
				style.id = 'tmp_style';
				var style_text = '#tpl_cnt .cardsorting .col_pics li {width:' + psize + 'px;height:' + psize + 'px;line-height:' + psize + 'px;}';
				style_text += '#tpl_cnt .cardsorting .col_pics li img {max-height:' + psize + 'px;}';
				//style_text += '#tpl_cnt .cardsorting .col_containers .container {width:'+csize+'px;height:'+csize+'px;}';
				//style_text += '#tpl_cnt .cardsorting .col_containers .container ul, .col_containers .container ul li {width:'+(csize-20)+'px;height:'+(csize-50)+'px;line-height:'+(csize-50)+'px;}';
				//style_text += '#tpl_cnt .cardsorting .col_containers .container ul li img {max-height:'+(csize-50)+'px;}';
				if (style.styleSheet)
					style.styleSheet.cssText = style_text;
				else
					style.appendChild(document.createTextNode(style_text));
				document.getElementsByTagName('head')[0].appendChild(style);

			},
			add_loupes = function () {
				$('#tpl_cnt .col_containers .container').each(function (ind) {
					var t = $(this), w = t.width(), h = t.height(), pos = t.position();
					$('<div>').addClass('loupe').css({
					}).insertBefore('.col_pics').on('click tap', function (evt) {
						evt.preventDefault();
						var objs = t.find('li'),
								size = calc_size(objs.length, '#main'),
								fitw = ($('#main').width() % size / 2) - 10,
								fith = ($('#main').height() % size / 2) - 10,
								ov = $('<div class="ui-widget-overlay" style="z-index: 30;"></div>').appendTo('#main'),
								dlg = $('<div class="ui-dialog" style="z-index: 31; max-width:100%"></div>').appendTo('#main'),
								ul = $('<ul>').addClass('popup-list').appendTo(dlg);

						objs.each(function () {
							var li = $('<li>').html($(this).html()).appendTo(ul).css({
								'width': (size - 20) + 'px', 'height': (size - 20) + 'px', 'line-height': (size - 20) + 'px',
							}),
									div = li.find('div').css('max-width', ''),
									img = li.find('img').css('max-height', (size - 20) + 'px');

							div.css('max-width', img.width() + 'px');
						});

						ov.add(ul).on('click tap', function (evt) {
							if (evt.target == this || evt.target.parentNode == this) {
								ov.remove();
								dlg.remove()
							}
						});
						var fitw = ($('#main').width() - ul.width()) / 2 - 10,
								fith = ($('#main').height() - ul.height()) / 2 - 10;
						ul.css('padding-top', fith > 0 ? fith + 'px' : 0).css('padding-left', fitw > 0 ? fitw + 'px' : 0);
					});
				});
			};

	$.ui.sortable.prototype._generatePosition = function (event) {
		var containment, co, top, left,
				o = this.options,
				scroll = this.cssPosition === "absolute" && !(this.scrollParent[ 0 ] !== document && $.contains(this.scrollParent[ 0 ], this.offsetParent[ 0 ])) ? this.offsetParent : this.scrollParent,
				pageX = event.pageX,
				pageY = event.pageY;

		//Cache the scroll
		if (!this.offset.scroll) {
			this.offset.scroll = {top: scroll.scrollTop(), left: scroll.scrollLeft()};
		}

		/*
		 * - Position constraining -
		 * Constrain the position to a mix of grid, containment.
		 */

		// If we are not dragging yet, we won't check for options
		if (this.originalPosition) {
			if (this.containment) {
				if (this.relative_container) {
					co = this.relative_container.offset();
					containment = [
						this.containment[ 0 ] + co.left,
						this.containment[ 1 ] + co.top,
						this.containment[ 2 ] + co.left,
						this.containment[ 3 ] + co.top
					];
				} else {
					containment = this.containment;
				}

				if (event.pageX - this.offset.click.left < containment[0]) {
					pageX = containment[0] + this.offset.click.left;
				}
				if (event.pageY - this.offset.click.top < containment[1]) {
					pageY = containment[1] + this.offset.click.top;
				}
				if (event.pageX - this.offset.click.left > containment[2]) {
					pageX = containment[2] + this.offset.click.left;
				}
				if (event.pageY - this.offset.click.top > containment[3]) {
					pageY = containment[3] + this.offset.click.top;
				}
			}

			if (o.grid) {
				//Check for grid elements set to 0 to prevent divide by 0 error causing invalid argument errors in IE (see ticket #6950)
				top = o.grid[1] ? this.originalPageY + Math.round((pageY - this.originalPageY) / o.grid[1]) * o.grid[1] : this.originalPageY;
				pageY = containment ? ((top - this.offset.click.top >= containment[1] || top - this.offset.click.top > containment[3]) ? top : ((top - this.offset.click.top >= containment[1]) ? top - o.grid[1] : top + o.grid[1])) : top;

				left = o.grid[0] ? this.originalPageX + Math.round((pageX - this.originalPageX) / o.grid[0]) * o.grid[0] : this.originalPageX;
				pageX = containment ? ((left - this.offset.click.left >= containment[0] || left - this.offset.click.left > containment[2]) ? left : ((left - this.offset.click.left >= containment[0]) ? left - o.grid[0] : left + o.grid[0])) : left;
			}

		}

		return {
			top: (
					pageY - // The absolute mouse position
					this.offset.click.top - // Click offset (relative to the element)
					this.offset.relative.top - // Only for relative positioned nodes: Relative offset from element to offset parent
					this.offset.parent.top + // The offsetParent's offset without borders (offset + border)
					(this.cssPosition === "fixed" ? -this.scrollParent.scrollTop() : this.offset.scroll.top)
					) / window.gScale,
			left: (
					pageX - // The absolute mouse position
					this.offset.click.left - // Click offset (relative to the element)
					this.offset.relative.left - // Only for relative positioned nodes: Relative offset from element to offset parent
					this.offset.parent.left + // The offsetParent's offset without borders (offset + border)
					(this.cssPosition === "fixed" ? -this.scrollParent.scrollLeft() : this.offset.scroll.left)
					) / window.gScale
		};

	};
	$.ui.sortable.prototype._convertPositionTo = function (d, pos) {

		if (!pos) {
			pos = this.position;
		}
		var mod = d === "absolute" ? 1 : -1,
				scroll = this.cssPosition === "absolute" && !(this.scrollParent[0] !== document && $.contains(this.scrollParent[0], this.offsetParent[0])) ? this.offsetParent : this.scrollParent,
				scrollIsRootNode = (/(html|body)/i).test(scroll[0].tagName);

		return {
			top: (
					pos.top * window.gScale + // The absolute mouse position
					this.offset.relative.top * mod + // Only for relative positioned nodes: Relative offset from element to offset parent
					this.offset.parent.top * mod - // The offsetParent's offset without borders (offset + border)
					((this.cssPosition === "fixed" ? -this.scrollParent.scrollTop() : (scrollIsRootNode ? 0 : scroll.scrollTop())) * mod)
					),
			left: (
					pos.left * window.gScale + // The absolute mouse position
					this.offset.relative.left * mod + // Only for relative positioned nodes: Relative offset from element to offset parent
					this.offset.parent.left * mod - // The offsetParent's offset without borders (offset + border)
					((this.cssPosition === "fixed" ? -this.scrollParent.scrollLeft() : scrollIsRootNode ? 0 : scroll.scrollLeft()) * mod)
					)
		};

	};


	return {
		/* elem - element, where the data is rendered
		 data - <component> element to render
		 state - current state (if the question is already answered) */
		init_question: function (elem, data, state, r, cb) {
			var cells = data.find('cell'), ncells = cells.length;
			$('#tpl_cnt').css('position', 'relative');
			if (state) {
				pictures = state.pictures;
				show_cells = state.cells;
			} else {
				show_cells = get_random_elements(cells, 4);
				var n = 0, ns = [];
				show_cells.each(function () {
					var l = $(this).find('object').length;
					n += l;
					ns.push(l);

				});
				var coef = 15 / n, n = 15;
				pictures = $([]);
				show_cells.each(function (ind) {
					var objs = $(this).find('object').data('cont_id', ind);
					if (coef < 1) {
						pictures = pictures.add(get_random_elements(objs, (ind == show_cells.length - 1 ? n : Math.floor(ns[ind] * coef))));
						n -= Math.floor(ns[ind] * coef);
					} else {
						pictures = pictures.add(objs);
					}
				});
				pictures = util.array_shuffle(pictures);
			}


			n = pictures.length;
			ncells = show_cells.length;
			$(elem).html('<div class="cardsorting"><div class="col_titles"></div><div class="col_containers"></div><ul class="col_pics"></ul></div>');

			$('#tpl_cnt').css('overflow', 'visible');
			show_cells.each(function (ind) {
				$('#tpl_cnt .col_titles').append('<div class="title">' + $(this).find('title').text() + '</div>');
			});
			show_cells.each(function (ind) {
				$('#tpl_cnt .col_containers').append('<div class="container"><ul id="cont_' + ind + '" data-ind="' + ind + '"></ul><div class="control">\
													<i class="next">&gt;</i><i class="prev">&lt;</i>\
													</div></div>');
			});

			$('#tpl_cnt .col_pics').css('height', parseInt($('#tpl_cnt').css('max-height')) - $('#tpl_cnt .col_titles').height() - $('#tpl_cnt .col_containers').height() + 'px');
			psize = calc_size(n, '#tpl_cnt .col_pics') - 6, csize = 117;

			create_style(psize, csize);


			$('#tpl_cnt .col_containers').find('i').on('click tap', function (evt) {
				evt.preventDefault();
				var obj = $(this).parents('.container').find('ul');
				if ($(this).hasClass('next')) {
					obj.children().first().appendTo(obj);
				} else {
					obj.children().last().prependTo(obj);
				}
			});

			if (state) {
				pictures.each(function () {
					var li = $('<li>'), cid = $(this).data('placed');
					li.data('cont_id', $(this).data('cont_id')).data('pic', $(this))
							.append(r.render_image($(this).attr('picture'), true, $(this).text(), 'auto', 'auto'))
							.appendTo('#tpl_cnt #cont_' + cid);
					var img = li.find('img');
					img.parent().css('max-width', img.width() + 'px');
					li.css({'position': 'absolute', 'top': ((csize - img.height()) / 2) + 'px', 'left': '0'});
				});
			} else {
				pictures.each(function () {
					var li = $('<li>');
					li.data('cont_id', $(this).data('cont_id')).data('pic', $(this))
							.append(r.render_image($(this).attr('picture'), true, $(this).text(), 'auto', 'auto'))
							.appendTo('#tpl_cnt .col_pics');
				});


				$('#tpl_cnt .col_pics').sortable({
					connectWith: "#tpl_cnt .col_containers ul",
					receive: function (evt, ui) {
						var item = ui.item;
						item.css({'position': '', 'top': '', 'left': ''});
						//item.find('img').css('max-height',psize+'px');
						item.find('div').css('max-width', '');
						if ($('#tpl_cnt .col_pics li').length > 0) {
							$('#check_btn').addClass('inactive');
						} else {
							$('#check_btn').removeClass('inactive');
						}
					}
				});
				$('#tpl_cnt .col_containers ul').sortable({
					connectWith: "#tpl_cnt .col_containers ul, #tpl_cnt .col_pics",
					receive: function (evt, ui) {
						var item = ui.item,
								img = item.find('img'); //.css('max-height',(csize-50)+'px');
						item.find('div').css('max-width', img.width() + 'px');
						item.css({'position': 'absolute', 'top': ((csize - img.height()) / 2) + 'px', 'left': '0'});
						item.appendTo(this);
						var pic = item.data('pic');
						pic.data('placed', $(this).attr('data-ind'));
						if ($('#tpl_cnt .col_pics li').length > 0) {
							$('#check_btn').addClass('inactive');
						} else {
							$('#check_btn').removeClass('inactive');
						}
					}
				});
			}

			if (typeof cb == 'function') {
				cb();
			}
		},
		/* cd - callback, function(result,score,state),
		 result - failed, passed, partial (-1, 1, 0), score - 0-100, state - state to save and resore when returned to this question */
		process_answer: function (cb) {
			if ($('#tpl_cnt .col_pics li').length > 0) {
				return false;
			}
			var num_result = 0, state = {pictures: pictures, cells: show_cells};
			$('.cardsorting ul.ui-sortable').sortable('destroy');
			$('#tpl_cnt .col_containers ul').each(function () {
				var cont_id = $(this).attr('data-ind');
				$(this).find('li').each(function () {
					if ($(this).data('cont_id') == cont_id) {
						$(this).children().addClass('border_correct');
						num_result++;
					} else {
						$(this).children().addClass('border_incorrect');
					}
				});
			});
			add_loupes();
			num_result = num_result < 0 ? 0 : num_result * 100 / pictures.length;
			cb(num_result < 100 ? -1 : 1, num_result, state);
			return true;
		},
		show_correct: function () {
			$('#tpl_cnt .col_containers li').each(function () {
				$(this).children().removeClass('border_correct border_incorrect');
				$(this).appendTo('#cont_' + $(this).data('cont_id'));
			});
		},
		resize: function () {
			/*psize = calc_size(pictures.length,'#tpl_cnt .col_pics')-6, csize = calc_size(show_cells.length,'#tpl_cnt .col_containers')-10;
			 create_style(psize,csize);
			 $('#tpl_cnt .col_containers li').each(function(){
			 var item = $(this),
			 img = item.find('img'), div = item.find('div');
			 div.css('max-width','');
			 div.css('max-width',img.width()+'px');
			 item.css({'position':'absolute','top':((csize-50-img.height())/2)+'px','left':'0'});
			 });
			 var loupes = $('.loupe');
			 if (loupes.length > 0) {
			 loupes.remove();
			 add_loupes();
			 }*/
		}
	};
});
