define(['jquery', 'util'], function ($, util) {
	var correct = [], cnt = null, sel_size = [];
	return {
		/* elem - element, where the data is rendered
		 data - <component> element to render
		 state - current state (if the question is already answered) */
		init_question: function (elem, data, state, r, cb) {

			var ind = parseInt(data.attr('text_indent')), font = data.attr('text_size');

			correct = [];
			sel_size = [];

			var style = document.createElement('style'), style_txt = '';
			style.type = 'text/css';
			style.id = 'tmp_style';
			if (ind) {
				if (ind > 0) {
					style_txt += '.comboboxtest > p {text-indent: ' + ind + 'px}';
				} else {
					style_txt += '.comboboxtest > p {text-indent: ' + ind + 'px; padding-left: ' + (-ind) + 'px}';
				}
			}
			if (font) {
				style_txt += '.comboboxtest {font-size:' + font + 'px;}';
				style_txt += '#main .ui-menu .ui-menu-item {font-size:' + font + 'px;}';
			}
			style.innerHTML = style_txt;
			document.getElementsByTagName('head')[0].appendChild(style);



			var res = util.get_html(data.find('text'));

			if (data.find('text').children().length == 0) {
				res = '<p>' + res.replace(/\r\n/g, '</p><p>').replace(/\n/g, '</p><p>') + '</p>';
			}
			var res_arr = res.replace(/&#/g, '[[!--ampdash--]]').split('#'), rl = res_arr.length, res = '';
			for (var i = 0; i < rl - 1; i += 2) {
				res += res_arr[i].replace(/\[\[\!--ampdash--\]\]/g, '&#');
				sel_size[i / 2] = 0;
				var sel_arr = res_arr[i + 1].split('~');
				res += '<select data-id="' + (i / 2) + '">'; //+'<option selected="selected" disabled="disabled" hidden="hidden" class="op-default" value="-">-</option>';
				for (var j = 0; j < sel_arr.length; j++) {
					if (sel_arr[j][0] == '^') {
						correct[i / 2] = j;
						sel_arr[j] = sel_arr[j].substr(1);
					}
					sel_size[i / 2] = Math.max(sel_size[i / 2], sel_arr[j].length);
					if (sel_arr[j] == ' ')
						sel_arr[j] = '&#160;';
					res += '<option value="' + j + '" ' + ((state && state[i / 2] == j) ? 'selected = "selected"' : '') + '>' + sel_arr[j] + '</option>';
				}
				res += '</select>';
			}
			res += res_arr[rl - 1];
			cnt = $(elem).html('<div class="comboboxtest">' + res.replace(/\[\[\!--ampdash--\]\]/g, '&#') + '</div>');
			if (!state)
				$('.comboboxtest select').each(function () {
					this.selectedIndex = -1
				});
			$('.comboboxtest select').selectmenu({
				appendTo: '#main',
				position: {
					using: function (a, b) {
						b.element.element.css({
							'top': b.target.element[0].offsetTop + b.target.height - $('#tpl_cnt').scrollTop() + 'px',
							'left': b.target.element[0].offsetLeft + 13 + 'px'
						});
					}
				},
				change: function (e, ui) {
					var selects = cnt.find('select');
					$('#' + this.id + '-button').addClass('noph');
					selects.each(function () {
						$(this).removeClass('correct incorrect').selectmenu('instance').button.removeClass('cb_correct cb_incorrect')
						if (this.selectedIndex == -1) {
//							$('#check_btn').addClass('inactive');
							return;
						}
					});
				},
				open: function (e, u) {
					$('#' + this.id + '-menu').parent().css("width", $('#' + this.id + '-button').width() + 'px');
					$('#' + this.id + '-menu').css("width", $('#' + this.id + '-button').width() + 'px');
					var selects = cnt.find('select');
					selects.each(function () {
						$(this).removeClass('correct incorrect').selectmenu('instance').button.removeClass('cb_correct cb_incorrect')
					});
				}
			});
			if (state)
				$('.ui-selectmenu-button').addClass('noph');
			$('#tpl_cnt').off('scroll').on('scroll', function () {
				$('.comboboxtest select').selectmenu('close');
			});
			$('.comboboxtest select').each(function (ind) {
				if (sel_size[ind] == 1)
					$(this).selectmenu('instance').button.addClass('onesymb');
			});
			if (typeof cb == 'function') {
				cb();
			}
		},
		/* cd - callback, function(result,score,state),
		 result - failed, passed, partial (-1, 1, 0), score - 0-100, state - state to save and resore when returned to this question */
		process_answer: function (cb, forceNotAllChoosedCheck, forceNotDoneCheck) {
			if (typeof forceNotAllChoosedCheck == 'undefined') {
				forceNotAllChoosedCheck = true;
			}
			if (typeof forceNotDoneCheck == 'undefined') {
				forceNotDoneCheck = false;
			}
			var selected = 0, num_result = 0, state = [], l = correct.length, selects = cnt.find('select'), rightAnser = true, notAllChoosed = false;
			selects.each(function () {
				if (!forceNotAllChoosedCheck && this.value == '') {
					notAllChoosed = true;
				}
				state.push(this.value);
				if (this.selectedIndex !== -1) {
					selected = 1;
				}
			});
			if (!forceNotDoneCheck && !selected) {
				return false;
			}

			//check for all choosed is right
			for (var i = 0; i < l; i++) {
				if (state[i] == '') {
					continue;
				}
				if (correct[i] == state[i]) {
				} else {
					rightAnser = false;
				}
			}
			if (rightAnser && notAllChoosed) {
				cb(0, 0, state);
				return true;
			}

			var wrongSelects = [];
			for (var i = 0; i < l; i++) {
				if (state[i] == '') {
					continue;
				}
				if (correct[i] == state[i]) {
					num_result++;
					cnt.find('select[data-id=' + i + ']').addClass('correct').attr('disabled', true).selectmenu('instance').button.addClass('cb_correct');
				} else {
					num_result--;
					wrongSelects.push(i);
				}
			}


			for (var i = 0; i < wrongSelects.length; i++) {
				cnt.find('select[data-id=' + wrongSelects[i] + ']').addClass('incorrect').attr('disabled', true).selectmenu('instance').button.addClass('cb_incorrect');
			}
			$('.comboboxtest select').selectmenu('disable');


			num_result = num_result < 0 ? 0 : num_result * 100 / l;
			cb(num_result < 100 ? -1 : 1, num_result, state);
			return true;
		},
		show_correct: function () {
			var l = correct.length, el;
			for (var i = 0; i < l; i++) {
				el = cnt.find('select[data-id=' + i + ']');
				if (el.hasClass('incorrect')) {
					el.removeClass('incorrect').val(correct[i]).attr('disabled', true).selectmenu('refresh');
					el.selectmenu('instance').button.removeClass('cb_incorrect').addClass('cb_corrected');
				}
			}
		},
		enable_answers: function () {
			var l = correct.length;
			for (var i = 0; i < l; i++) {
				cnt.find('select[data-id=' + i + ']').attr('disabled', false).selectmenu('enable').button;
			}
		},
		disable_answers: function () {
			var l = correct.length;
			for (var i = 0; i < l; i++) {
				cnt.find('select[data-id=' + i + ']').attr('disabled', true).selectmenu('disable').button;
			}
		},
//		reset_highlight:function(){
//			var l = correct.length;
//			for (var i = 0; i < l; i++) {
//				cnt.find('select[data-id=' + i + ']').removeClass('incorrect correct').selectmenu('instance').button.removeClass('incorrect correct');
//			}
//		},
		get_correct_answer_text: function () {
			var curr_task = app_data.cur_task,
					curr_component = app_data.tasks[curr_task].current,
					$nodes = $($(app_data.data.find('task').get(curr_task)).find('component').get(curr_component)).find('text');
			var texts = [];
			$nodes.each(function () {
				var res = util.get_html($(this));

				if ($(this).children().length == 0) {
					res = '<p>' + res.replace(/\r\n/g, '</p><p>').replace(/\n/g, '</p><p>') + '</p>';
				}
				var res_arr = res.replace(/&#/g, '[[!--ampdash--]]').split('#'), rl = res_arr.length, res = '';
				for (var i = 0; i < rl - 1; i += 2) {
					res += res_arr[i].replace(/\[\[\!--ampdash--\]\]/g, '&#');
					sel_size[i / 2] = 0;
					var sel_arr = res_arr[i + 1].split('~');
					for (var j = 0; j < sel_arr.length; j++) {
						if (sel_arr[j][0] == '^') {
							res += sel_arr[j].substr(1);
						}
					}
				}
				res += res_arr[rl - 1];
				var text = $(res.replace(/\[\[\!--ampdash--\]\]/g, '&#').replace('<br/>','[[br]]')).text().replace('[[br]]','<br/>');

				texts.push(text);
			});
			return texts.join('<br/>');


//			var l = correct.length, texts = [];
//			for (var i = 0; i < l; i++) {
//				var text = cnt.find('select[data-id=' + i + '] option[value=' + correct[i] + ']').text();
//				texts.push(text);
//			}
//			return texts.join('<br/>');
		}

	};
});