define(['jquery', 'util', 'jquery-ui', 'jquery.ui.touch-punch'], function ($, util) {
	function isOverAxis(x, reference, size) {
		return (x > reference) && (x < (reference + size));
	}
	var columns = [], words = [], in_order, align, orientation, text_size, ctop,
			parse_data = function (data) {
				columns = [];
				words = [];
				in_order = data.attr('in_order') || 'no';
				align = data.attr('align') || 'center';
				orientation = data.attr('orientation') || 'vertical';
				text_size = data.attr('text_size') || 0;
				var id = 0;
				data.find('object').each(function (ind) {
					var t = $(this), title = util.get_html(t.find('title')),
							//&#60; 
							w = t.find('text').text().trim().replace(/&#/g, '[[!--ampdash--]]').split('#'),
							l = w.length, i = l, col = columns.length;
					while (i--) {
						if (w[i].length > 0) {
							words.push({word: w[i].trim().replace(/\[\[\!--ampdash--\]\]/g, '&#'), col: col, id: id++});
						}
					}
					columns.push(title);
				});
				if (in_order == 'yes') {
					words.sort(function (a, b) {
						return a.word.toLowerCase().replace(/[^a-zа-я0-9]/g, '') > b.word.toLowerCase().replace(/[^a-zа-я0-9]/g, '') ? 1 : -1
					});
				} else {
					words = util.array_shuffle(words);
				}

			},
			render = function (elem, state) {
				var res = '', lc = columns.length, lw = words.length, w = words, i, j, k;
				if (!state) {
					var res1 = '<div class="cols">';
					for (i = 0; i < lc; i++) {
						res1 += '<div class="col"><h3>' + columns[i] + '</h3><ul data-colid="' + i + '" id="col_' + i + '"></ul></div>';
					}
					res1 += '</div>';
					var res2 = '<ul id="unsorted">';
					for (i = 0; i < lw; i++) {
						res2 += '<li id="word_' + i + '" data-wordid="' + w[i].id + '">' + w[i].word + '</li>';
					}
					res2 += '</ul>';
					if (orientation == 'horizontal')
						res = res1 + res2;
					else
						res = res2 + res1;
				} else {
					res += '<div class="cols">';
					for (i = 0; i < lc; i++) {
						res += '<div class="col"><h3>' + columns[i] + '</h3><ul data-colid="' + i + '" id="col_' + i + '">';
						for (j = 0; j < lw; j++) {
							for (k = 0; k < lw; k++) {
								if (w[k].id == state.data[j].id && state.data[j].col == i) {
									res += '<li id="word_' + k + '" data-wordid="' + w[k].id + '">' + w[k].word + '</li>';
								}
							}
						}
						res += '</ul></div>';
					}
					res += '</div>';
				}
				$(elem).css('overflow-y', 'hidden').html('<div class="textsorting ' + orientation + '">' + res + '</div>');
				if (text_size) {
					$('.textsorting').css('font-size', text_size + 'px');
				}
				ctop = 0;
				var mh = parseInt($(elem).css('max-height'));
				if (!state) {
					//if (orientation == 'horizontal') {
					ctop = $('#unsorted').height() + 15;
					$('#unsorted').css('height', ctop + 'px');
					if (ctop > mh)
						$('<div>').addClass('error_message').appendTo(elem).html('ВНИМАНИЕ! Данные не помещаются на экран');
					//}
					$('#unsorted').sortable({cursor: 'move', tolerance: "pointer", scroll: false, connectWith: ".cols ul", receive: function (e, ui) {
							ui.item.css('display', 'inline-block');
							if ($('#unsorted li').length > 0)
								$('#check_btn').addClass('inactive');
							else
								$('#check_btn').removeClass('inactive');
							/*if (orientation == 'horizontal') {
							 $('#unsorted').css('height','auto');
							 ctop = Math.max($('#unsorted').height(),ctop);
							 $('#unsorted').css('height',ctop+'px');
							 $('.cols').css('margin-top',15+'px').css('min-height',(mh-ctop-15)+'px');
							 $('.cols .col ul').css('min-height',((mh-ctop-15))+'px');
							 }*/
						}});
					$('.cols ul').sortable({cursor: 'move', tolerance: "pointer", scroll: false, connectWith: "#unsorted, .cols ul", receive: function (e, ui) {
							ui.item.css('display', 'inline');
							var ch = 0;
							$('.cols ul').css('height', '').each(function () {
								if ($(this).height() > ch)
									ch = $(this).height()
							});
							$('.cols ul').css('height', ch + 40 + 'px');
							if ($('#unsorted li').length > 0)
								$('#check_btn').addClass('inactive');
							else
								$('#check_btn').removeClass('inactive');
						}});
				} else {
					ctop = state.ul_height;
				}
				if (orientation == 'horizontal') {
					$('.cols').css('min-height', (mh - ctop - 30) + 'px');
				} else {
					$('.cols').css('min-height', (mh - 30) + 'px');
				}
				$('.cols .col').css('width', (100 / columns.length) + '%').css('text-align', align);
				var ch = $('.cols').height();
				$('.cols .col ul').each(function () {
					$(this).css('min-height', (ch - $(this).parent().find('h3').height()) + 'px')
				});
			};

	$.ui.sortable.prototype._generatePosition = function (event) {
		var containment, co, top, left,
				o = this.options,
				scroll = this.cssPosition === "absolute" && !(this.scrollParent[ 0 ] !== document && $.contains(this.scrollParent[ 0 ], this.offsetParent[ 0 ])) ? this.offsetParent : this.scrollParent,
				pageX = event.pageX,
				pageY = event.pageY;

		//Cache the scroll
		if (!this.offset.scroll) {
			this.offset.scroll = {top: scroll.scrollTop(), left: scroll.scrollLeft()};
		}

		/*
		 * - Position constraining -
		 * Constrain the position to a mix of grid, containment.
		 */

		// If we are not dragging yet, we won't check for options
		if (this.originalPosition) {
			if (this.containment) {
				if (this.relative_container) {
					co = this.relative_container.offset();
					containment = [
						this.containment[ 0 ] + co.left,
						this.containment[ 1 ] + co.top,
						this.containment[ 2 ] + co.left,
						this.containment[ 3 ] + co.top
					];
				} else {
					containment = this.containment;
				}

				if (event.pageX - this.offset.click.left < containment[0]) {
					pageX = containment[0] + this.offset.click.left;
				}
				if (event.pageY - this.offset.click.top < containment[1]) {
					pageY = containment[1] + this.offset.click.top;
				}
				if (event.pageX - this.offset.click.left > containment[2]) {
					pageX = containment[2] + this.offset.click.left;
				}
				if (event.pageY - this.offset.click.top > containment[3]) {
					pageY = containment[3] + this.offset.click.top;
				}
			}

			if (o.grid) {
				//Check for grid elements set to 0 to prevent divide by 0 error causing invalid argument errors in IE (see ticket #6950)
				top = o.grid[1] ? this.originalPageY + Math.round((pageY - this.originalPageY) / o.grid[1]) * o.grid[1] : this.originalPageY;
				pageY = containment ? ((top - this.offset.click.top >= containment[1] || top - this.offset.click.top > containment[3]) ? top : ((top - this.offset.click.top >= containment[1]) ? top - o.grid[1] : top + o.grid[1])) : top;

				left = o.grid[0] ? this.originalPageX + Math.round((pageX - this.originalPageX) / o.grid[0]) * o.grid[0] : this.originalPageX;
				pageX = containment ? ((left - this.offset.click.left >= containment[0] || left - this.offset.click.left > containment[2]) ? left : ((left - this.offset.click.left >= containment[0]) ? left - o.grid[0] : left + o.grid[0])) : left;
			}

		}

		return {
			top: (
					pageY - // The absolute mouse position
					this.helper.outerHeight() / 2 * window.gScale -
					//this.offset.click.top	-												// Click offset (relative to the element)
					this.offset.relative.top - // Only for relative positioned nodes: Relative offset from element to offset parent
					this.offset.parent.top + // The offsetParent's offset without borders (offset + border)
					(this.cssPosition === "fixed" ? -this.scrollParent.scrollTop() : this.offset.scroll.top)
					) / window.gScale,
			left: (
					pageX - // The absolute mouse position
					this.helper.outerWidth() / 2 * window.gScale -
					//this.offset.click.left -												// Click offset (relative to the element)
					this.offset.relative.left - // Only for relative positioned nodes: Relative offset from element to offset parent
					this.offset.parent.left + // The offsetParent's offset without borders (offset + border)
					(this.cssPosition === "fixed" ? -this.scrollParent.scrollLeft() : this.offset.scroll.left)
					) / window.gScale
		};

	};
	$.ui.sortable.prototype._convertPositionTo = function (d, pos) {

		if (!pos) {
			pos = this.position;
		}
		var mod = d === "absolute" ? 1 : -1,
				scroll = this.cssPosition === "absolute" && !(this.scrollParent[0] !== document && $.contains(this.scrollParent[0], this.offsetParent[0])) ? this.offsetParent : this.scrollParent,
				scrollIsRootNode = (/(html|body)/i).test(scroll[0].tagName);

		return {
			top: (
					pos.top * window.gScale + // The absolute mouse position
					this.offset.relative.top * mod + // Only for relative positioned nodes: Relative offset from element to offset parent
					this.offset.parent.top * mod - // The offsetParent's offset without borders (offset + border)
					((this.cssPosition === "fixed" ? -this.scrollParent.scrollTop() : (scrollIsRootNode ? 0 : scroll.scrollTop())) * mod)
					),
			left: (
					pos.left * window.gScale + // The absolute mouse position
					this.offset.relative.left * mod + // Only for relative positioned nodes: Relative offset from element to offset parent
					this.offset.parent.left * mod - // The offsetParent's offset without borders (offset + border)
					((this.cssPosition === "fixed" ? -this.scrollParent.scrollLeft() : scrollIsRootNode ? 0 : scroll.scrollLeft()) * mod)
					)
		};

	};
	/*$.ui.sortable.prototype._intersectsWith = function(item) {
	 
	 var x1 = this.positionAbs.left,
	 x2 = x1 + this.helperProportions.width,
	 y1 = this.positionAbs.top,
	 y2 = y1 + this.helperProportions.height,
	 l = item.left,
	 r = l + item.width,
	 t = item.top,
	 b = t + item.height,
	 dyClick = this.offset.click.top,
	 dxClick = this.offset.click.left,
	 isOverElementHeight = ( this.options.axis === "x" ) || ( ( y1 + dyClick ) > t && ( y1 + dyClick ) < b ),
	 isOverElementWidth = ( this.options.axis === "y" ) || ( ( x1 + dxClick ) > l && ( x1 + dxClick ) < r ),
	 isOverElement = isOverElementHeight && isOverElementWidth;
	 
	 if ( this.options.tolerance === "pointer" ||
	 this.options.forcePointerForContainers ||
	 (this.options.tolerance !== "pointer" && this.helperProportions[this.floating ? "width" : "height"] > item[this.floating ? "width" : "height"])
	 ) {
	 return isOverElement;
	 } else {
	 
	 return (l < x1 + (this.helperProportions.width / 2) && // Right Half
	 x2 - (this.helperProportions.width / 2) < r && // Left Half
	 t < y1 + (this.helperProportions.height / 2) && // Bottom Half
	 y2 - (this.helperProportions.height / 2) < b ); // Top Half
	 
	 }
	 };
	 
	 $.ui.sortable.prototype._intersectsWithPointer = function(item) {
	 
	 var isOverElementHeight = (this.options.axis === "x") || isOverAxis(this.positionAbs.top + this.offset.click.top, item.top, item.height),
	 isOverElementWidth = (this.options.axis === "y") || isOverAxis(this.positionAbs.left + this.offset.click.left, item.left, item.width),
	 isOverElement = isOverElementHeight && isOverElementWidth,
	 verticalDirection = this._getDragVerticalDirection(),
	 horizontalDirection = this._getDragHorizontalDirection();
	 
	 if (!isOverElement) {
	 return false;
	 }
	 console.log(this.positionAbs.top, this.positionAbs.left, item.top, item.left);
	 return this.floating ?
	 ( ((horizontalDirection && horizontalDirection === "right") || verticalDirection === "down") ? 2 : 1 )
	 : ( verticalDirection && (verticalDirection === "down" ? 2 : 1) );
	 
	 };
	 
	 $.ui.sortable.prototype._intersectsWithSides = function(item) {
	 
	 var isOverBottomHalf = isOverAxis(this.positionAbs.top + this.offset.click.top, item.top + (item.height/2), item.height),
	 isOverRightHalf = isOverAxis(this.positionAbs.left + this.offset.click.left, item.left + (item.width/2), item.width),
	 verticalDirection = this._getDragVerticalDirection(),
	 horizontalDirection = this._getDragHorizontalDirection();
	 
	 if (this.floating && horizontalDirection) {
	 return ((horizontalDirection === "right" && isOverRightHalf) || (horizontalDirection === "left" && !isOverRightHalf));
	 } else {
	 return verticalDirection && ((verticalDirection === "down" && isOverBottomHalf) || (verticalDirection === "up" && !isOverBottomHalf));
	 }
	 
	 };*/

	return {
		/* elem - element, where the data is rendered
		 data - <component> element to render
		 state - current state (if the question is already answered) */
		init_question: function (elem, data, state, r, cb) {
			parse_data(data);
			render(elem, state);
			if (typeof cb == 'function') {
				cb();
			}
		},
		/* cd - callback, function(result,score,state),
		 result - failed, passed, partial (-1, 1, 0), score - 0-100, state - state to save and resore when returned to this question */
		process_answer: function (cb) {
			if ($('#unsorted li').length > 0) {
				return false;
			}
			$('.textsorting ul.ui-sortable').sortable('destroy');
			var wl = words.length, num_result = 0, state = {ul_height: $('#unsorted').height(), data: []};
			for (var i = 0; i < wl; i++) {
				var colid = $('#word_' + i).parent().attr('data-colid');
				state.data.push({id: $('#word_' + i).attr('data-wordid'), col: colid});
				if (colid == words[i].col) {
					$('#word_' + i).addClass('correct');
					num_result++;
				} else {
					$('#word_' + i).addClass('incorrect');
				}
			}
			num_result *= 100 / wl;
			cb(num_result < 100 ? -1 : 1, num_result, state);
			return true;
		},
		show_correct: function () {
			var wl = words.length;
			for (var i = 0; i < wl; i++) {
				var el = $('li[data-wordid=' + words[i].id + ']'), col_id = 'col_' + words[i].col;
				if (el.parent().attr('id') != col_id) {
					$('li[data-wordid=' + words[i].id + ']').removeClass('incorrect').addClass('corrected').appendTo('#col_' + words[i].col);
				}
			}
		}/*,
		 resize: function(w,h) {
		 if (orientation == 'horizontal') {
		 $('#unsorted').css('height','auto');
		 ctop = $('#unsorted').height() || 30;
		 $('#unsorted').css('height',ctop+'px');
		 $('.cols').css('top',ctop+15+'px').css('min-height',(h-ctop-15)+'px');
		 } else {
		 ctop = 0;	
		 $('.cols').css('min-height',(h-15)+'px');
		 }
		 $('.cols .col ul').css('min-height',((h-ctop-15)-$('.cols .col ul').position().top)+'px');
		 }*/
	};
});